<template>
  <div class="editor">
    <info-box
      v-if="$store.state.debugMode"
      :time="realTime"
      :musical-time="musicalTime"
      :cursor-position="mousePosition"
      :signature="piece.signature"
      :second-unit="track.secondUnit"
      :selected-label="actions.getSelected()"
    />
    <limited-canvas-switcher
      v-slot="{ source: unscaledSource, index, scale, zoom }"
      :canvases="canvases"
      :signature="piece.signature"
      :actions="actions"
      :possible-increments="possibleIncrements"
      :show-translator="showTranslator"
      class="editor-body"
    >
      <source-scaler
        v-slot="{ source }"
        :source="unscaledSource"
        :scale="scale.value"
        :is-sync-editor="true"
      >
        <!-- The scroll container, sends scroll events and can order scrolls -->
        <!-- Passes the view rectangle and the scroll function to its children -->
        <!-- Here we only listen to the events of the first scroller -->
        <canvas-scroller
          :auto-zoom="source.type === '3d'"
          :zoom="zoom"
          :width="source.width"
          :has-minimap="true"
          :scale="scale.value"
          :pixel-unit="source.pixelUnit"
          @updatezoom="(z) => scrollerUpdateZoom(z, source)"
        >
          <!-- The API provider by the scroller component -->
          <template #default="{ viewRect, actions: { goTo, goToRange } }">
            <!-- The canvas, displays data passed in props and emit events -->
            <label-canvas
              :render-staves="false"
              :get-label="(id) => actions.getLabel(id)"
              :sorted-labels="
                source.type === 'wave' ? actions.getAllSortedLabels() : actions.getSortedLabels()"
              :selected-id="actions.selectedId"
              :is-focused="focusedSourceIndex === index"
              :source="source"
              :zoom="appZoom.value"
              @all-mousemove="(e) => onMouseMove(e)"
              @all-focusin="focusedSourceIndex = index"
              @label-dblclick="focusEditor()"
              @label-keydown.enter="focusEditor()"
            >
              <template #svgInjector>
                <canvas-source-base :source="source" />
              </template>
              <template #default="{ canvas }">
                <!-- The behaviors, consume events and commit changes -->

                <!-- Unique behaviors (only on the first canvas) -->

                <template v-if="index === 0">
                  <b-zoom-on-ctrl-scroll
                    :zoom="appZoom"
                    :canvas="canvas"
                  />
                  <b-zoom-on-window-resize
                    :zoom="appZoom"
                    :canvas="canvas"
                  />
                </template>

                <!-- Unique behaviors (only on focused canvas when not tapping) -->
                <template v-if="index === focusedSourceIndex && !isTapping">
                  <!-- alt-ctrl-zoom to scale left-right -->
                  <b-zoom-on-ctrl-scroll
                    v-if="!source.shouldSnap"
                    :zoom="scale"
                    :canvas="canvas"
                    use-alt
                  />
                  <b-delete-on-key
                    :canvas="canvas"
                    :actions="actions"
                  />
                  <b-player-control-on-key
                    :canvas="canvas"
                    :pixel-unit="source.pixelUnit"
                    :playing.sync="playing"
                    :real-time="realTime"
                    @update:realTime="setRealTime"
                  />
                </template>
                <!-- Per canvas behaviors: outside tapping mode -->
                <template v-if="!isTapping">
                  <b-prev-next-on-key
                    :att="index"
                    :canvas="canvas"
                    :actions="actions"
                  />
                  <b-scroll-on-target
                    :canvas="canvas"
                    :actions="actions"
                  />
                  <b-follow-on-play
                    :canvas="canvas"
                    :scroll-to="goTo"
                    :playing="playing"
                    :view-rect="viewRect"
                  />
                  <b-select-on-click
                    :canvas="canvas"
                    :actions="actions"
                  />
                  <b-select-on-tab-focus
                    :canvas="canvas"
                    :actions="actions"
                  />
                  <b-unselect-on-canvas-click
                    :canvas="canvas"
                    :actions="actions"
                  />
                  <!-- Editing behaviors: outside tapping mode -->
                  <!-- Use from-onset on the score, and from pixel on the wave -->
                  <b-create-sync-on-dbl-click
                    :actions="actions"
                    :canvas="canvas"
                    :pixel-unit="source.pixelUnit"
                  />
                  <b-edit-sync-on-drag
                    :actions="actions"
                    :canvas="canvas"
                    :pixel-unit="source.pixelUnit"
                  />
                  <b-scroll-on-edge-drag
                    :canvas="canvas"
                    :scroll-to="goTo"
                    :view-rect="viewRect"
                  />
                  <b-scroll-to-label
                    :actions="actions"
                    :canvas="canvas"
                    :scroll-to-range="goToRange"
                    :pixel-unit="source.pixelUnit"
                  />
                </template>
                <!-- Only when tapping, all canvases -->
                <template v-if="isTapping">
                  <b-follow-on-play
                    :canvas="canvas"
                    :scroll-to="goTo"
                    :playing="playing"
                    :view-rect="viewRect"
                    can-follow-back
                    force-follow
                  />
                </template>
                <!-- On countdown start, scroll to cursor minus a margin -->
                <b-scroll-on-load
                  v-if="isCountdown && scoreCursor"
                  :start-onset="scoreCursor - 8"
                  :pixel-unit="source.pixelUnit"
                  :scroll-to="goTo"
                />
                <!-- canvas cursor uses realTime on a spectrogram -->
                <!-- and musical time on a score -->
                <!-- here scoreCursor is the same as musical time, except when tapping -->
                <b-canvas-cursor
                  :canvas="canvas"
                  :pixel-unit="source.pixelUnit"
                  :musical-time="scoreCursor"
                  :real-time="realTime"
                  :focus-cursor="(isTapping || isCountdown) && source.type === 'score'"
                  :pages="source.pages"
                />
                <b-seek-on-shift-click
                  :canvas="canvas"
                  :pixel-unit="source.pixelUnit"
                  :pages="source.pages"
                  @update:realTimeSync="setRealTime($event)"
                  @update:time="setTime($event)"
                />
              </template>
            </label-canvas>
          </template>
          <!-- The minimap scrollbar replacement -->
          <template #minimap="{ viewRect, actions: { goTo } }">
            <minimap
              v-slot="{ canvas }"
              :sorted-labels="
                source.type === 'wave' ? actions.getAllSortedLabels() : actions.getSortedLabels()"
              :source="source"
              :go-to="goTo"
              :view-rect="viewRect"
              :show-image="piece.settings['score-minimap']"
            >
              <b-canvas-cursor
                :pixel-unit="source.pixelUnit"
                :musical-time="scoreCursor"
                :focus-cursor="(isTapping || isCountdown) && source.type === 'score'"
                :real-time="realTime"
                :pages="source.pages"
              />
              <b-seek-on-shift-click
                :canvas="canvas"
                :pages="source.pages"
                :pixel-unit="source.pixelUnit"
                @update:realTimeSync="setRealTime($event)"
                @update:time="setTime($event)"
              />
            </minimap>
          </template>
        </canvas-scroller>
      </source-scaler>
    </limited-canvas-switcher>
    <!-- The editor bar and player container -->
    <sync-tools
      ref="tools"
      :piece="piece"
      :actions="actions"
      :is-tapping.sync="isTapping"
      :is-countdown.sync="isCountdown"
      :playing.sync="playing"
      :real-time="realTime"
      :set-time="setTime"
      :possible-increments="possibleIncrements"
      :second-unit="track.secondUnit"
      @toggle-translator="showTranslator = !showTranslator"
      @skip="(incr) => skip(incr)"
      @reset-sync="updateSubTable"
    >
      <template #player>
        <!-- The audio player. Warning: -->
        <!-- Changing musical time will not affect player -->
        <!-- You need to call setTime -->
        <player-container
          ref="player"
          v-model="playing"
          :audio="track"
          :musical-time.sync="musicalTime"
          :real-time.sync="realTime"
        />
      </template>
    </sync-tools>
    <sync-color-generator />
  </div>
</template>

<script lang="ts">
import {
  Vue, Component, Watch, Ref, Prop, PropSync,
} from 'vue-property-decorator';
import LabelCanvas from '@/components/canvas/LabelCanvas.vue';

// Behaviors
import BSelectOnClick from '@/components/behaviors/shared/BSelectOnClick.vue';
import BDeleteOnKey from '@/components/behaviors/shared/BDeleteOnKey.vue';
import BSelectOnTabFocus from '@/components/behaviors/shared/BSelectOnTabFocus.vue';
import BPrevNextOnKey from '@/components/behaviors/shared/BPrevNextOnKey.vue';
import BUnselectOnCanvasClick from '@/components/behaviors/shared/BUnselectOnCanvasClick.vue';

import BZoomOnCtrlScroll from '@/components/behaviors/zoom/BZoomOnCtrlScroll.vue';
import BZoomOnWindowResize from '@/components/behaviors/zoom/BZoomOnWindowResize.vue';
import BScrollOnEdgeDrag from '@/components/behaviors/scroll/BScrollOnEdgeDrag.vue';
import BScrollOnLoad from '@/components/behaviors/scroll/BScrollOnLoad.vue';
import BScrollToLabel from '@/components/behaviors/scroll/BScrollToLabel.vue';
import BScrollOnTarget from '@/components/behaviors/scroll/BScrollOnTarget.vue';
import BMinimapCursor from '@/components/behaviors/scroll/BMinimapCursor.vue';
import BMinimapClickScroll from '@/components/behaviors/scroll/BMinimapClickScroll.vue';

import BCanvasCursor from '@/components/behaviors/player/BCanvasCursor.vue';
import BFollowOnPlay from '@/components/behaviors/player/BFollowOnPlay.vue';
import BPlayerControlOnKey from '@/components/behaviors/player/BPlayerControlOnKey.vue';
import BSeekOnShiftClick from '@/components/behaviors/player/BSeekOnShiftClick.vue';
import BScrollToSelectedOnKey from '@/components/behaviors/scroll/BScrollToSelectedOnKey.vue';

// Sync behaviors
import BCreateSyncOnDblClick from '@/components/behaviors/synchronization/BCreateSyncOnDblClick.vue';
import BEditSyncOnDrag from '@/components/behaviors/synchronization/BEditSyncOnDrag.vue';

// Addons

import type { LimitedCanvas } from '@/components/canvas-switchers/LimitedCanvasSwitcher.vue';
import LimitedCanvasSwitcher from '@/components/canvas-switchers/LimitedCanvasSwitcher.vue';
import CanvasScroller from '@/components/canvas-addons/CanvasScroller.vue';
import SourceScaler from '@/components/canvas-addons/SourceScaler.vue';
import Minimap from '@/components/canvas-addons/Minimap.vue';
import SyncColorGenerator from '@/components/canvas-addons/SyncColorGenerator.vue';
import SyncTools from '@/components/toolbars/SyncTools.vue';
import PlayerContainer from '@/components/players/PlayerContainer.vue';

// Logic

import type {
  Piece, Onset, Audio, Second, EditableUnit, Source,
} from '@/data';
import { SourceType } from '@/data';
import Zoom from '@/logic/Zoom';
import type SynchronizationActions from '@/synchronization-logic/SynchronizationActions';
import SynchronizationActionsImpl from '@/synchronization-logic/SynchronizationActionsImpl';
import type { Position } from 'vue-router/types/router';
import CanvasSourceBase from '@/components/canvas-sources/CanvasSourceBase.vue';
import type ITools from './toolbars/ITools';
import type IPlayerContainer from './players/IPlayerContainer';
import type { Increment } from './toolbars/synchronization/TapBar.vue';
import InfoBox from './canvas-addons/InfoBox.vue';

/**
 * The sync editor integration
 *
 * Displays a piece sync file and lets a user modify it
 */
@Component({
  components: {
    CanvasSourceBase,
    // All the canvas behaviors used
    BSelectOnClick,
    BDeleteOnKey,
    BUnselectOnCanvasClick,
    BSelectOnTabFocus,
    BSeekOnShiftClick,
    BCanvasCursor,
    BScrollOnLoad,
    BScrollOnEdgeDrag,
    BPlayerControlOnKey,
    BFollowOnPlay,
    BPrevNextOnKey,
    BZoomOnCtrlScroll,
    BZoomOnWindowResize,
    BScrollOnTarget,
    BScrollToLabel,
    BScrollToSelectedOnKey,

    // All the sync behavior used
    BCreateSyncOnDblClick,
    BEditSyncOnDrag,

    // All the minimap behaviors used
    BMinimapCursor,
    BMinimapClickScroll,

    // All the canvas add-ons and UI tools
    CanvasScroller,
    LimitedCanvasSwitcher,
    LabelCanvas,
    Minimap,
    SourceScaler,
    SyncColorGenerator,
    SyncTools,
    PlayerContainer,
    InfoBox,
  },
})
export default class SynchronizationEditor extends Vue {
  // Main states

  @Prop()
  piece!: Piece;

  @Prop({ required: true })
  track!: Audio;

  @Prop()
  unit!: EditableUnit;

  @PropSync('clean')
  isClean!: boolean;

  appZoom = new Zoom();

  canvases: LimitedCanvas[] = [];

  actions: SynchronizationActions = {} as SynchronizationActions;

  showTranslator = false;

  // Sub states

  created() {
    this.resetPiece();
    this.updateIncrements();
  }

  // Anything that should be reset if the piece changes
  @Watch('piece')
  @Watch('track')
  resetPiece() {
    this.player?.reset();
    // All scores in the piece
    const scores = this.piece.sources
      .filter((s) => s.type === SourceType.Score || s.type === SourceType.Image3D);
    // All waves associated with the current track
    const waves = this.piece.sources.filter((s) => s.track === this.track);
    this.canvases = [{
      availableSources: waves,
    }, {
      availableSources: scores,
    }];
    this.resetSync();
  }

  updateSubTable(subTable = 'null') {
    this.actions.updateSubTable(subTable);
  }

  @Watch('unit')
  @Watch('unit.reInitTableCounter')
  resetSync() {
    const actions = new SynchronizationActionsImpl(
      this.piece,
      this.unit,
      0,
    );
    this.actions = actions;
  }

  /** The index of the last focused source */
  focusedSourceIndex = 0;

  // Audio management

  // If the selected player is playing
  playing = false;

  // Tapping implementation

  /** If the user is currently tapping to the beat to input sync points */
  isTapping = false;

  /** If currently waiting to start tapping */
  isCountdown = false;

  scoreCursor: Onset | null = null;

  skipIncr = 1;

  @Watch('actions.increment')
  @Watch('actions.selectCount')
  @Watch('realTime')
  @Watch('musicalTime')
  @Watch('isTapping')
  updateScoreCursor() {
    if (this.isTapping || this.isCountdown) {
      this.scoreCursor = this.actions.getNextTappingOnset(this.skipIncr);
    } else {
      this.scoreCursor = this.musicalTime;
    }
  }

  skip(increment: number) {
    this.skipIncr = increment;
  }

  @Watch('actions.editCount')
  onEdit() {
    if (this.isClean !== !this.actions.editCount) {
      this.isClean = !this.actions.editCount;
    }
  }

  @Ref('tools')
  tools!: ITools;

  @Ref()
  player?: IPlayerContainer;

  setTime(time: Onset) {
    this.player?.setMusicalTime(time);
  }

  setRealTime(time: Second) {
    this.player?.setRealTime(time);
  }

  focusEditor() {
    (this.$refs['bScrollToLabel-0'] as BScrollToLabel).scrollToLabel();
    (this.$refs['bScrollToLabel-1'] as BScrollToLabel).scrollToLabel();
    if (!this.isTapping) this.tools.focus();
  }

  // The current time of the player
  // Current time should never be set, except to null
  // It is exclusively updated by the player
  // To change it, use setTime on any player
  readonly musicalTime: Onset | null = null;

  readonly realTime: Second | null = null;

  scrollerUpdateZoom(zoom: Zoom, source: Source) {
    source.setZoom(zoom);
  }

  possibleIncrements: Increment[] = [];

  @Watch('piece.signature')
  updateIncrements() {
    const { beatIncrement, measureIncrement } = this.piece.signature;

    this.possibleIncrements = [
      { value: measureIncrement, text: 'increments.measure' },
      { value: measureIncrement * 2, text: 'increments.twoMeasures' },
      { value: measureIncrement * 4, text: 'increments.fourMeasures' },
      { value: beatIncrement / 2, text: 'increments.halfBeat' },
      { value: beatIncrement, text: 'increments.time' },
      { value: beatIncrement * 2, text: 'increments.timeSecond' },
      { value: beatIncrement * 3, text: 'increments.timeThird' },
      { value: beatIncrement * 4, text: 'increments.timeFourth' },
    ];
  }

  mousePosition: Position = { x: 0, y: 0 };

  onMouseMove(e: MouseEvent) {
    this.mousePosition.x = e.x;
    this.mousePosition.y = e.y;
  }
}

</script>
<style scoped lang="scss">
.editor {
  width: 100%;
  height: 100%;
  display: flex;
  flex-direction: column;
  flex-wrap: nowrap;
  overflow: hidden;
}
.editor-body {
  flex-grow: 1;
  flex-shrink: 1;
  height: 0;
  overflow-y: auto;
  min-height: 2em;
  display:flex;
  flex-direction: column;
}
</style>
